 /* <!-- ***** BEGIN LICENSE BLOCK *****
   - Version: MPL 1.1/GPL 2.0/LGPL 2.1
   -
   - The contents of this file are subject to the Mozilla Public License Version
   - 1.1 (the "License"); you may not use this file except in compliance with
   - the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License.
   -
   -
   - The Initial Developer of the Original Code is Andy Edmonds.
   - Portions created by the Initial Developer are Copyright (C) 2001
   - the Initial Developer. All Rights Reserved.
   -
   -
   - Alternatively, the contents of this file may be used under the terms of
   - either the GNU General Public License Version 2 or later (the "GPL"), or
   - the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   - in which case the provisions of the GPL or the LGPL are applicable instead
   - of those above. If you wish to allow use of your version of this file only
   - under the terms of either the GPL or the LGPL, and not to allow others to
   - use your version of this file under the terms of the MPL, indicate your
   - decision by deleting the provisions above and replace them with the notice
   - and other provisions required by the LGPL or the GPL. If you do not delete
   - the provisions above, a recipient may use your version of this file under
   - the terms of any one of the MPL, the GPL or the LGPL.
   -
   - ***** END LICENSE BLOCK ***** 
   */
var prevNode;


function moveUp(node) {
	var newNode = node.cloneNode("true");
	newNode.setAttribute("position", (newNode.getAttribute("position") - 1));

	var prevRow = node_before(node);
	var prevRowNode = prevRow.cloneNode("true");
	prevRowNode.setAttribute("position", (parseInt(prevRowNode.getAttribute("position")) + 1.0));
	var tableNode = node.parentNode;
	
	var reattachee = tableNode.replaceChild( newNode, prevRow);
	var reattachee = tableNode.replaceChild(prevRowNode, node);
	rebuild();
}

function moveDown(node) {
	var newNode = node.cloneNode("true");
	newNode.setAttribute("position", (parseInt(newNode.getAttribute("position")) + 1.0));

	var nextRow = node_after(node);
	
	var nextRowNode = nextRow.cloneNode("true");
	nextRowNode.setAttribute("position", (nextRowNode.getAttribute("position") - 1));
	var tableNode = node.parentNode;
	
	var reattachee = tableNode.replaceChild( newNode, nextRow);
	var reattachee = tableNode.replaceChild(nextRowNode, node);
	rebuild();
} 

function rebuild() {

	var numtasks = 6;

	var count =0;
	var movedown = "<span onclick='moveDown(this.parentNode.parentNode);'> <img src='/uzilla/bin/my/images/icon_down_12px.gif' width='12' height='12' hspace='4'></span>";
	var moveup = "<span onclick='moveUp(this.parentNode.parentNode)'> <img src='/uzilla/bin/my/images/icon_up_12px.gif' width='12' height='12' hspace='4'></span>";
	var thenode;
	var prevbutton;
	var tasks = document.getElementsByTagName("TR");
	for(var i=0; i<tasks.length;i++) {
		
		thenode = tasks.item(i);
		//dump("node is " + thenode.getAttribute("position") + "\n");
		//dump("Row " + i + " " + thenode.getAttribute("position") + " now, after " + thenode.getAttribute("origposition") + "\n");
		if(thenode.getAttribute("position")) {
		count++;
		//dump(" down but is " + first_child(thenode).nodeName  + "\n");
		downbutton = node_after(first_child(thenode));
		//dump("html is " + downbutton.innerHTML + "\n");
		upbutton = node_after(downbutton); 
		//dump(upbutton);
		if(count == 1) {
			upbutton.innerHTML="";
		} else {
			upbutton.innerHTML = moveup;
		}
		if(count  == numtasks) {
			downbutton.innerHTML="";
		} else {
			downbutton.innerHTML = movedown;			
		}
	}
	}
	//updateMasterList();
}

function updateMasterList() {
	var taskidlist= new Array(1);
	var tasks = document.getElementsByTagName("TR");
	var count = 0;
	for(var i=0; i<tasks.length;i++) {
		thenode = tasks.item(i);
		if(thenode.getAttribute("taskid")) {
		taskidlist[count] =  thenode.getAttribute("taskid");
		count++;
		}
	}
	alert( taskidlist.join(","));
	
}
